<?php

	class IDEALCHECKOUT_FOR_OSCOMMERCE_2_2
	{
		// Return the software name
		public static function getSoftwareName()
		{
			return 'osCommerce 2.2+';
		}



		// Return the software code
		public static function getSoftwareCode()
		{
			return str_replace('_', '-', substr(basename(__FILE__), 0, -4));
		}



		// Return path to main cinfig file (if any)
		public static function getConfigFile()
		{
			return SOFTWARE_PATH . DS . 'includes' . DS . 'configure.php';
		}



		// Return path to main cinfig file (if any)
		public static function getConfigData()
		{
			$sConfigFile = self::getConfigFile();

			// Detect DB settings via configuration file
			if(is_file($sConfigFile))
			{
				return file_get_contents($sConfigFile);
			}

			return '';
		}



		// Find default database settings
		public static function getDatabaseSettings($aSettings)
		{
			$aSettings['db_prefix'] = 'os_';
			$sConfigData = self::getConfigData();

			if(!empty($sConfigData))
			{
				$aSettings['db_host'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/define\(\'DB_SERVER\', \'([^\']+)\'\);/');
				$aSettings['db_user'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/define\(\'DB_SERVER_USERNAME\', \'([^\']+)\'\);/');
				$aSettings['db_pass'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/define\(\'DB_SERVER_PASSWORD\', \'([^\']+)\'\);/');
				$aSettings['db_name'] = IDEALCHECKOUT_INSTALL::getFileValue($sConfigData, '/define\(\'DB_DATABASE\', \'([^\']+)\'\);/');
				$aSettings['db_prefix'] = '';
				$aSettings['db_type'] = (version_compare(PHP_VERSION, '5.3', '>') ? 'mysqli' : 'mysql');
			}

			return $aSettings;
		}



		// See if current software == self::$sSoftwareCode
		public static function isSoftware()
		{
			$aFiles = array();
			$aFiles[] = SOFTWARE_PATH . DS . 'includes' . DS . 'configure.php';
			$aFiles[] = SOFTWARE_PATH . DS . 'account.php';
			$aFiles[] = SOFTWARE_PATH . DS . 'account_edit.php';
			$aFiles[] = SOFTWARE_PATH . DS . 'account_history.php';
			$aFiles[] = SOFTWARE_PATH . DS . 'account_history_info.php';

			foreach($aFiles as $sFile)
			{
				if(!is_file($sFile) && !is_dir($sFile))
				{
					return false;
				}
			}

			return true;
		}




		// Install plugin, return text
		public static function doInstall($aSettings)
		{
			IDEALCHECKOUT_INSTALL::doInstall($aSettings);



			$sql = "SELECT `configuration_key` FROM `" . $aSettings['db_prefix'] . "configuration` WHERE `configuration_key` = 'MODULE_PAYMENT_IDEALCHECKOUTIDEAL_STATUS' LIMIT 1;";
			if(!idealcheckout_database_isRecord($sql)) // See if key was already added
			{
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "configuration` (`configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `set_function`, `date_added`) values ('Enable Plugin', 'MODULE_PAYMENT_IDEALCHECKOUTIDEAL_STATUS', 'True', 'Accept iDEAL Payments', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now());";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "configuration` (`configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `date_added`) values ('Sort order', 'MODULE_PAYMENT_IDEALCHECKOUTIDEAL_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())";
				idealcheckout_database_execute($sql);

				$sql = "SELECT `configuration_id`, `configuration_value` FROM `" . $aSettings['db_prefix'] . "configuration` WHERE `configuration_key` = 'MODULE_PAYMENT_INSTALLED' LIMIT 1;";
				if($aRecord = idealcheckout_database_getRecord($sql))
				{
					$sql = "UPDATE `" . $aSettings['db_prefix'] . "configuration` SET `configuration_value` = '" . idealcheckout_escapeSql($aRecord['configuration_value']) . ";idealcheckoutideal.php' WHERE `configuration_id` = '" . $aRecord['configuration_id'] . "' LIMIT 1;";
					idealcheckout_database_execute($sql);
				}
			}

			$sql = "SELECT `language_id` FROM `" . $aSettings['db_prefix'] . "languages` WHERE `code` = 'nl' LIMIT 1;";
			$aRecord = idealcheckout_database_getRecord($sql);

			if($aRecord)
			{				
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('100', '" . $aRecord['language_id'] . "', 'Betaling ontvangen (gecontroleerd)')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('101', '" . $aRecord['language_id'] . "', 'Betaling ontvangen')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('102', '" . $aRecord['language_id'] . "', 'Betaling in behandeling')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('103', '" . $aRecord['language_id'] . "', 'Betaling open')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('104', '" . $aRecord['language_id'] . "', 'Betaling geannuleerd')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('105', '" . $aRecord['language_id'] . "', 'Betaling mislukte')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('106', '" . $aRecord['language_id'] . "', 'Betaling verlopen')";
				idealcheckout_database_execute($sql);
				
			}
			else
			{
				
				// Add default labels for iDEAL status
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('100', '1', 'Payment success (verified)')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('101', '1', 'Payment success')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('102', '1', 'Payment pending')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('103', '1', 'Payment open')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('104', '1', 'Payment canceled')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('105', '1', 'Payment failure')";
				idealcheckout_database_execute($sql);

				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES ('106', '1', 'Payment expired')";
				idealcheckout_database_execute($sql);
				
			}		

			$sql = "SHOW COLUMNS FROM `" . $aSettings['db_prefix'] . "idealcheckout_settings` LIKE `webshop_package`";
			
			if(!$aColumn = idealcheckout_database_getRecord($sql))
			{
				$sql = "INSERT INTO `" . $aSettings['db_prefix'] . "idealcheckout_settings` SET
`id` = NULL, 
`keyname` = 'webshop_package',
`value` = 'oscommerce'";
				idealcheckout_database_execute($sql);
				
			}
			else
			{
				$sql = "UPDATE `" . $aSettings['db_prefix'] . "idealcheckout_settings` SET
`value` = 'oscommerce' WHERE (`keyname` = 'webshop_package') LIMIT 1";
				idealcheckout_database_execute($sql);
			}
			
			
			
			
			return true;
		}



		// Install plugin, return text
		public static function getInstructions($aSettings)
		{
			$sHtml = '';
			$sHtml .= '<ol>';
			$sHtml .= '<li>Log in op de beheeromgeving van uw webshop.</li>';
			$sHtml .= '<li>Ga naar Modules / Payment.</li>';
			$sHtml .= '<li>Klik rechts bovenin op "Install Module (??)".</li>';
			$sHtml .= '<li>Klik de gewenste betaalmethode aan, en klik op "Install Module".</li>';
			$sHtml .= '<li>Herhaar stap 3 en 4 voor de overige betaalmethoden die u wilt aanbieden in uw webshop.</li>';
			$sHtml .= '</ol>';

			return $sHtml;
		}
	}

?>